// Code generated by goa v3.14.1, DO NOT EDIT.
//
// oci service
//
// Command:
// $ goa gen github.com/PingCAP-QE/ee-apps/dl/design

package oci

import (
	"context"
	"io"

	goa "goa.design/goa/v3/pkg"
)

// OCI artifacts download service
type Service interface {
	// ListFiles implements list-files.
	ListFiles(context.Context, *ListFilesPayload) (res []string, err error)
	// DownloadFile implements download-file.
	DownloadFile(context.Context, *DownloadFilePayload) (res *DownloadFileResult, body io.ReadCloser, err error)
}

// ServiceName is the name of the service as defined in the design. This is the
// same value that is set in the endpoint request contexts under the ServiceKey
// key.
const ServiceName = "oci"

// MethodNames lists the service method names as defined in the design. These
// are the same values that are set in the endpoint request contexts under the
// MethodKey key.
var MethodNames = [2]string{"list-files", "download-file"}

// DownloadFilePayload is the payload type of the oci service download-file
// method.
type DownloadFilePayload struct {
	// OCI artifact repository
	Repository string
	// OCI artifact tag
	Tag string
	// file name in OCI artifact
	File string
}

// DownloadFileResult is the result type of the oci service download-file
// method.
type DownloadFileResult struct {
	// Length is the downloaded content length in bytes.
	Length int64
	// Content-Disposition header for downloading
	ContentDisposition string
}

// ListFilesPayload is the payload type of the oci service list-files method.
type ListFilesPayload struct {
	// OCI artifact repository
	Repository string
	// OCI artifact tag
	Tag string
}

// MakeInvalidFilePath builds a goa.ServiceError from an error.
func MakeInvalidFilePath(err error) *goa.ServiceError {
	return goa.NewServiceError(err, "invalid_file_path", false, false, false)
}

// MakeInternalError builds a goa.ServiceError from an error.
func MakeInternalError(err error) *goa.ServiceError {
	return goa.NewServiceError(err, "internal_error", false, false, false)
}
